# all files / lighthouse-core/audits/ aria-valid-attr.js

100% Statements 11/11
100% Branches 4/4
100% Functions 3/3
100% Lines 11/11

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65

    1×
    1×

    8×

    2×
    2×

    2×

    4×
    1×

    3×
    3×

    1×
     /**
     * @license
     * Copyright 2016 Google Inc. All rights reserved.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */

    'use strict';

    const Audit = require('./audit');
    const Formatter = require('../formatters/formatter');

    class ARIAValidAttr extends Audit {
      /**
       * @return {!AuditMeta}
       */
      static get meta() {
        return {
          category: 'Accessibility',
          name: 'aria-valid-attr',
          description: 'Element aria-* attributes are valid ARIA attributes',
          requiredArtifacts: ['Accessibility']
        };
      }

      /**
       * @param {!Artifacts} artifacts
       * @return {!AuditResult}
       */
      static audit(artifacts) {
        const rule =
            artifacts.Accessibility.violations.find(result => result.id === 'aria-valid-attr');

        return ARIAValidAttr.generateAuditResult({
          value: typeof rule === 'undefined',
          debugString: this.createDebugString(rule),
          extendedInfo: {
            formatter: Formatter.SUPPORTED_FORMATS.ACCESSIBILITY,
            value: rule
          }
        });
      }

      static createDebugString(rule) {
        if (typeof rule === 'undefined') {
          return '';
        }

        const elementsStr = rule.nodes.length === 1 ? 'element' : 'elements';
        return `${rule.help} (Failed on ${rule.nodes.length} ${elementsStr})`;
      }
    }

    module.exports = ARIAValidAttr;